# a single-minded HTTP server

import SocketServer
import BaseHTTPServer

PORT = 8008

DATA = \
"<rss version=\"2.0\">\n\
   <channel>\n\
      <title>My Channel</title>\n\
      <link>http://example.org/</link>\n\
      <description>A minimal feed</description>\n\
      <item>\n\
         <title>My First Item</title>\n\
         <description>This is the first post</description>\n\
      </item>\n\
      <item>\n\
         <title>My Second Item</title>\n\
         <description>This is the second post</description> \n\
      </item> \n\
      <item> \n\
         <title>My Third Item</title> \n\
         <description>This is the third post</description> \n\
      </item> \n\
   </channel> \n\
</rss>"

class InflexibleServer(BaseHTTPServer.BaseHTTPRequestHandler):
    def do_HEAD(self):
        self.send_head() 
        
    def do_GET(self):
        self.send_head()
        print "Request Header:"
        print self.headers
        print "---"
        self.wfile.write(DATA)
        self.wfile.close()

    def send_head(self):
        self.send_response(200)
        self.send_header("Content-Type", "application/rss+xml")
        self.end_headers()
        
httpd = SocketServer.ThreadingTCPServer(('', PORT), InflexibleServer)

print "serving at port", PORT
httpd.serve_forever()
