# a single-minded HTTP server with gzip capability

import SocketServer
import BaseHTTPServer
import string
import StringIO
import gzip

PORT = 8008

DATA = \
"<rss version=\"2.0\">\n\
   <channel>\n\
      <title>My Channel</title>\n\
      <link>http://example.org/</link>\n\
      <description>A minimal feed</description>\n\
      <item>\n\
         <title>My First Item</title>\n\
         <description>This is the first post</description>\n\
      </item>\n\
      <item>\n\
         <title>My Second Item</title>\n\
         <description>This is the second post</description> \n\
      </item> \n\
      <item> \n\
         <title>My Third Item</title> \n\
         <description>This is the third post</description> \n\
      </item> \n\
   </channel> \n\
</rss>"

class InflexibleZipServer(BaseHTTPServer.BaseHTTPRequestHandler):
    def do_HEAD(self):
        self.send_head() 
        
    def do_GET(self):
        self.send_head()
        print "Request Header:"
        print self.headers
        print "---"
        if self.canCompress:
            self.wfile.write(self.compress(DATA))
        else:
            self.wfile.write(DATA)
        self.wfile.close()

    def acceptsGzip(self):
        print self.headers
        encodings = self.headers.get('Accept-Encoding')
        if encodings != None:
            return (string.find(encodings, "gzip") != -1)
        return False
        
    def send_head(self):
        self.send_response(200)
        if self.acceptsGzip():
            self.canCompress = True
            self.send_header('Content-Encoding', 'gzip')
        else:
            self.canCompress = False
        self.send_header("Content-Type", "application/rss+xml")
        self.end_headers()

    def compress(self, data):
        print "Compressing!!"
        zipBuffer = StringIO.StringIO()
        zipFile = gzip.GzipFile(mode = 'wb',  fileobj = zipBuffer, compresslevel = 6)
        zipFile.write(data)
        zipFile.close()
        zipped = zipBuffer.getvalue()
        zipBuffer.close()
        return zipped
    
httpd = SocketServer.ThreadingTCPServer(('', PORT), InflexibleZipServer)

print "serving at port", PORT
httpd.serve_forever()
