<?php
function getFirstElementByTagName($parent, $name) {
  $maybeMatch = $parent->firstChild;

  while( ($maybeMatch->nodeName != $name) and !empty($maybeMatch) ){
    $maybeMatch = $maybeMatch->nextSibling;
  }
  return $maybeMatch;
}   

function getFirstValueByTagName($parent, $name) {
  $maybeMatch = getFirstElementByTagName($parent, $name); 
  if (!empty($maybeMatch)) {
    if (!empty($maybeMatch->firstChild)){
      return $maybeMatch->firstChild->nodeValue;
    }
  } 
  return '';   
}   

function appendTextNode($document, $parent, $name, $text){
  $element = $document->createElement($name);
  $textNode = $document->createTextNode($text);
  $element->appendChild($textNode);
  $parent->appendChild($element);
  return $parent;
}

function appendCleanTextNode($document, $parent, $name, $text){
  $text = escape($text);
  return appendTextNode($document, $parent, $name, $text);
}

function escape ($string){
	$string = str_replace ("<script", "<p style=\"color: red;\" ", $string);
	$string = str_replace ("</script>", "</p>", $string);
	$string = str_replace ("\\\"", "\"", $string);
	return htmlentities($string, ENT_QUOTES, 'utf-8');
}
?>
