<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output method="xml" indent="yes"/>
	
	<xsl:template match="/">
		<xsl:apply-templates/>
	</xsl:template>
	
	<xsl:template match="book">
		<xsl:text disable-output-escaping="yes">
    &lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"&gt;
  </xsl:text>
		<html>
			<head>
				<title>
					<xsl:value-of select="bookinfo/title"/>
				</title>
			</head>
			<body xml:lang="{@lang}" lang="{@lang}">
				<xsl:apply-templates/>
			</body>
		</html>
	</xsl:template>
	
	<xsl:template match="article">
		<div class="item">
			<h1>
				<xsl:value-of select="articleinfo/title"/>
			</h1>
			<p>
				<xsl:value-of select="para"/>
			</p>
		</div>
	</xsl:template>
	
	<xsl:template match="text()"/>
	
</xsl:stylesheet>
