<?php
// Uses the PEAR HTTP Request utility
// which also depends on the PEAR Net package.

require_once "Request.php";

// source file
$req =& new HTTP_Request("http://www.w3.org/2000/08/w3c-synd/home.rss");
$req->sendRequest();

// Check for HTTP 200 
if ( $req->getResponseCode() != '200' ) {
   die ( "Request failed: ".$req->getResponseCode() );
} 

$xml = $req->getResponseBody(); 

// XSLT file
$xsl = file_get_contents ('rss2svg.xslt') ;

$arguments = array(
     '/_xml' => $xml,
     '/_xsl' => $xsl
);


// create a new XSLT processor
$processor = xslt_create();

// transform 
$output = xslt_process($processor, 'arg:/_xml', 'arg:/_xsl', NULL, $arguments);

if ($result) {
        // set mime type
        header("Content-Type: image/svg+xml");
	// print it
	echo $output;
}

// clean up
xslt_free($processor);
?>