
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/*
 * Danny Ayers Sep 18, 2004
 * http://dannyayers.com
 * 
 */

public class LineInterpreter {

    private BufferedReader reader;

    public LineInterpreter() {
        InputStreamReader streamReader = new InputStreamReader(System.in);
        reader = new BufferedReader(streamReader);
    }

    /**
     * Reads a line from the console
     * sends it to the processor
     * echos the respone to the console
     */
    public void start() {
        String input = null;
        String output = null;
        try {
            while ((input = reader.readLine()) != null) {
                output = process(input);
                System.out.println(output);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Loops back unless line is "quit" 
     */
    public String process(String input) {
        if(input.equals("quit")){
            System.exit(0);
        }
        return input;
    }

    /**
     * Runs the default (echo) interpreter
     */
    public static void main(String[] args) {
        new LineInterpreter().start();
    }
}