/*
 * Danny Ayers Sep 18, 2004 http://dannyayers.com
 *  
 */

import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.XMLReader;

import com.fatdog.xmlEngine.ResultList;
import com.fatdog.xmlEngine.XQEngine;

public class XQ extends LineInterpreter {

    private XQEngine engine;

    public XQ() {
        engine = new XQEngine();
        installXMLReader();
        engine.setUseLexicalPrefixes(true);
    }

    private void installXMLReader() {

        try {
            SAXParserFactory parserFactory = SAXParserFactory.newInstance();
            parserFactory.setNamespaceAware(true);
            XMLReader xmlReader = parserFactory.newSAXParser().getXMLReader();
            engine.setXMLReader(xmlReader);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String process(String input) {
        if (input.startsWith("quit")) {
            System.exit(0);
        }
        if (input.startsWith("data")) {
            load(input.substring(5));
            return input.substring(5) + " loaded.";
        }
        if (input.startsWith("load")) {
            loadQueryFile(input.substring(5));
            return loadQueryFile(input.substring(5));
        }
        return query(input);
    }

    private String query(String input) {
        String output = "";
        System.out.println("'" + input + "' = ");
        try {
            ResultList results = engine.setQuery(input);
            output = results.emitXml();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return output;
    }

    private String loadQueryFile(String filename) {
        String output = "";
        try {
            ResultList results = engine.setQueryFromFile(filename);
            output = results.emitXml();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return output;
    }

    private void load(String filename) {
        try {
            engine.setDocument(filename);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new XQ().start();
    }
}