using System;
using System.Xml;
using System.Text;
using System.Net;
using System.IO;
using System.Collections;


namespace DefaultNamespace
{
	public class XmlRpcStruct
	{
		private XmlDocumentFragment structFragment;
		private XmlDocument document;
		private XmlElement structElement;
		
		public XmlRpcStruct(XmlDocument document)
		{
			this.document = document;
			this.structFragment = document.CreateDocumentFragment();
			structElement = document.CreateElement("struct");
			structFragment.AppendChild(structElement);
		}
		
		public void addMember(string name, string type, string value){
			XmlElement memberElement = document.CreateElement("member");
			structElement.AppendChild(memberElement);
			
			XmlElement valueElement = document.CreateElement("value");
			
			memberElement.AppendChild(valueElement);
			XmlElement typeElement = document.CreateElement(type);
			valueElement.AppendChild(typeElement);
			
			typeElement.AppendChild(document.CreateTextNode(value));
		}
		
		public override string ToString(){
			return structFragment.OuterXml.ToString();
		}
		
		public void setInnerXml(string xml){
			structFragment.InnerXml = xml;
		}
		
		public XmlDocumentFragment getFragment(){
			return structFragment;
		}
		
		public string getValue(string name){
			XmlNode named = structFragment.SelectSingleNode("//name[text()='"+name+"']");
			return getMemberValue(named);
		}
		
		public Hashtable getValues(){
			Hashtable hashtable = new Hashtable();
			string memberName;
			string memberValue;
			XmlNodeList namedNodes = structFragment.SelectNodes("//name");
		
			for (int i=0; i < namedNodes.Count; i++)
			{
				memberName = namedNodes[i].InnerText;
				Console.WriteLine(memberName);
				memberValue = getMemberValue(namedNodes[i]);
				hashtable.Add(memberName, memberValue);
			}
			return hashtable;
		}
		
		
		public string getMemberValue(XmlNode named){
			XmlNode valueNode = named.NextSibling;
			XmlNode typeNode = valueNode.SelectSingleNode("*");
			string memberValue = "";
			if(typeNode != null){
				memberValue = typeNode.InnerText;
			}else{
				memberValue = valueNode.InnerText;
			}
			return memberValue;
		}
	}
}
