using System;
using System.Xml;
using System.Text;
using System.Net;
using System.IO;
using System.Collections;


namespace DefaultNamespace{

  public class BloggerClient{
    string targetURI;
    
    public BloggerClient(){
    }
    
    public void setTargetURI(string targetURI){
      this.targetURI = targetURI;
    }
    
    public Hashtable getUserInfo(string appKey, string userName, 
                                       string password){
      MethodCall call = new MethodCall("blogger.getUserInfo");
      call.addParam("string", appKey);
      call.addParam("string", userName);
      call.addParam("string", password);
      
      Stream  responseStream = call.call(targetURI);
      
      XmlDocument responseDocument = new XmlDocument();
      
      responseDocument.Load(responseStream);
      
      Console.WriteLine(responseDocument.DocumentElement.OuterXml);
      responseStream.Close();
      
      XmlNode structNode = responseDocument.SelectSingleNode("/methodResponse/params/param/value/struct");
      
      XmlRpcStruct infoStruct = new XmlRpcStruct(responseDocument);
      infoStruct.setInnerXml(structNode.InnerXml);
      
      return infoStruct.getValues();
    }
    
      public Hashtable newPost(string appKey, string blogID, string userName, string password, string entryText, string publish){
  	
  	MethodCall call = new MethodCall("blogger.newPost");
  	
  	call.addParam("string", appKey);
  	call.addParam("string", blogID);
  	call.addParam("string", userName);
  	call.addParam("string", password);
  	call.addParam("string", entryText);
  	call.addParam("boolean", publish);
  	
  	Stream  responseStream = call.call(targetURI);
  	XmlDocument responseDocument = new XmlDocument();
  	responseDocument.Load(responseStream);
  	
  	Hashtable results;
  	XmlNode fault = responseDocument.SelectSingleNode("//fault");
  	
  	if(fault != null){
    results = extractStructValues(responseDocument);
  	} else {
    Console.WriteLine(responseDocument.DocumentElement.OuterXml);
    results = new Hashtable();
    string responseValue =
    	responseDocument.SelectSingleNode("//value").InnerText;
    results.Add("value", responseValue);
  	}
  	return results;
  }


    private Hashtable extractStructValues(XmlDocument document){
      XmlNode structNode = document.SelectSingleNode("//struct");
      XmlRpcStruct xmlRpcStruct = new XmlRpcStruct(document);
      xmlRpcStruct.setInnerXml(structNode.InnerXml);
      return xmlRpcStruct.getValues();
    }
    
  }
}
