using System;
using System.Xml;
using System.Text;
using System.Net;
using System.IO;

namespace DefaultNamespace {

  public class MethodCall {
    
    private XmlDocument document;
    private XmlElement paramsElement;
    
    public MethodCall(string name){
      document  = new XmlDocument();
      XmlElement root = document.CreateElement("methodCall");
      document.AppendChild(root);
      
      XmlElement methodNameElement = document.CreateElement("methodName");
      methodNameElement.AppendChild(document.CreateTextNode(name));
      root.AppendChild(methodNameElement);
      
      paramsElement = document.CreateElement("params");
      root.AppendChild(paramsElement);
    }
    
    public void addParam(string type, string value){
      XmlElement paramElement = document.CreateElement("param");
      paramsElement.AppendChild(paramElement);
      
      XmlElement valueElement = document.CreateElement("value");
      
      paramElement.AppendChild(valueElement);
      XmlElement typeElement = document.CreateElement(type);
      valueElement.AppendChild(typeElement);
      
      typeElement.AppendChild(document.CreateTextNode(value));  
    }
    
    public Stream call(string uri){

      HttpWebRequest request =
        (HttpWebRequest)WebRequest.Create(uri);
      
      request.Method = "POST";
      byte [] bytes = null;

      bytes = System.Text.Encoding.UTF8.GetBytes (ToString());
      request.ContentLength = bytes.Length;

      Stream outputStream = request.GetRequestStream ();
      outputStream.Write (bytes, 0, bytes.Length);
      outputStream.Close ();
      
      WebResponse response = request.GetResponse();
      return response.GetResponseStream();
    }
    
    public override string ToString(){
      return document.DocumentElement.OuterXml.ToString();
    }
  }
}
