using System;
using System.Collections;
using SemPlan.Carp.Core;
using SemPlan.Carp.Vocabularies;

namespace Rooster
{
	/// <summary>
	/// Description of CarpFeed.
	/// </summary>
	public class CarpFeed: FeedBase
	{
		private  ArrayList items = new ArrayList();
		
		public CarpFeed(IFeedStore store, string name, string uri):
			base(store, name, uri)
		{
		}
		
		
		public override ArrayList Items {
			get{
				items = getItems();
				return items;}
			set{ this.items = value;
			}
		}
		
		public override void loadData(){
			OnFeedEvent("Loading: "+URI);
			KnowledgeBase feedKB = ((CarpFeedStore)Store).getFeedKB(this);
			feedKB.include(URI);
			OnFeedEvent("Loaded: "+URI);
		}
		
		public ArrayList getItems(){
			KnowledgeBase feedKB =  ((CarpFeedStore)Store).getFeedKB(this);
			Rss.Item itemPattern = new Rss.Item();
			ArrayList items = new ArrayList();
			foreach (Rss.Item rssItem in itemPattern.findAllMatching(feedKB) ) {
				string uri = rssItem.ToString();
				string title = rssItem.title.ToString();
				string content = rssItem.description.ToString();
				Item item = new Item(uri, title, content);
				
				items.Add(item);
			}
			return items;
		}
	}
}
