using System;
using System.Collections;
using SemPlan.Carp.Core;
using SemPlan.Carp.Vocabularies;
using System.IO;
using SemPlan.RdfLib.XsltParser;

namespace  Rooster {
	
	public class CarpFeedStore: FeedStoreBase {
		
		public static XsltParserFactory ParserFactory = new XsltParserFactory();
		KnowledgeBase channelsKB;
		Hashtable feedKBs;
		
		
		public CarpFeedStore() {
			channelsKB = new KnowledgeBase(ParserFactory);
			feedKBs = new Hashtable();
		}
		
		public KnowledgeBase getFeedKB(IFeed feed){
			return (KnowledgeBase)feedKBs[feed];
		}
		
		public override void loadChannelsList(string filename){
			try {
				OnFeedEvent("Reading: "+filename);
				channelsKB.include(new StreamReader(filename), "");
			} catch (Exception e) {
				Console.WriteLine(e);
			}
			initFeedTable();
		}
		
		public override IFeed createFeed(string name, string uri){
			IFeed feed = new CarpFeed(this, name, uri);
			feed.Name = name;
			feed.URI = uri;
			return feed;
		}
		
		private void initFeedTable(){
			FeedTable = new Hashtable();
			Foaf.Agent pattern = new Foaf.Agent();
			
			foreach (Foaf.Agent agent in pattern.findAllMatching(channelsKB) ) {
				string name = agent[Foaf.name].ToString();
				foreach (Foaf.Document doc in agent.weblog) {
					try {
						string uri = doc[Rdfs.seeAlso][0].ToString();
						IFeed feed =  createFeed(name, uri);
						FeedTable.Add(name, feed);
						feedKBs.Add(feed, new KnowledgeBase(ParserFactory));
					} catch (Exception e) {
						Console.WriteLine( e );
					}
				}
			}
		}
	}
}
