using System;
using System.Collections ;
using System.Threading;
using System.Timers;

namespace  Rooster
{
	public abstract class FeedBase: FeedEventTrigger, IFeed
	{
		public abstract void loadData();
		
		public abstract ArrayList Items {
			get;
			set;
		}
		
		private IFeedStore store;
		
		private string uri;
		private string name;
		
		
		public FeedBase(IFeedStore store, string name, string uri){
			this.store = store;
			this.name = name;
			this.uri = uri;
		}
		
		public string Name {
			get{ return name;}
			set{ this.name = value;
			}
		}
		
		public string URI {
			get { return uri;}
			set { this.uri = value;
			}
		}
		
		public IFeedStore Store {
			get { return store;}
			set { this.store = value;}
		}
		
		public void update(){
			updateThread = new Thread(new ThreadStart(this.loadData));
			updateThread.Start();
		}
		
		public void updateEvent(object ob, System.Timers.ElapsedEventArgs arg){
			OnFeedEvent("Update: "+Name);
		}
		
		int UPDATE_PERIOD = 3600000;
		private Thread updateThread;
		private  System.Timers.Timer updateTimer;
		
		private void startTimerThread(){
			this.updateTimer = new System.Timers.Timer();
			this.updateTimer.Interval = UPDATE_PERIOD;
			this.updateTimer.Elapsed += new ElapsedEventHandler(updateEvent);
			this.updateTimer.Enabled = true;
		}
	}
}
