using System;
using System.Collections;

namespace Rooster
{
	public abstract class FeedStoreBase: FeedEventTrigger, IFeedStore
	{
		private Hashtable feedTable = new Hashtable();
		
		public FeedStoreBase()
		{
		}
		
		public abstract void loadChannelsList(string filename);
		public abstract IFeed createFeed(string name, string uri);
		
		public Hashtable FeedTable {
			get { return feedTable;}
			set { this.feedTable = value;
			}
		}
		
		public IDictionaryEnumerator GetFeedEnumerator(){
			return FeedTable.GetEnumerator();
		}
		
		public IFeed selectNamedFeed(string feedName){
			return (IFeed)FeedTable[feedName];
		}
		
		public void updateFeeds(){
			IDictionaryEnumerator enumerator  = GetFeedEnumerator();			
			while(enumerator.MoveNext()){
				IFeed feed = (IFeed)enumerator.Value;
				feed.update();
			}
		}
	}
}
