package org.imp;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class EnclosureSerializer extends FileEntrySerializer {

    public void addEnclosureEntry(EnclosureEntry entry) {
        super.addEntry(entry);
        addEnclosure(entry);
    }

    private void addEnclosure(EnclosureEntry entry) {
        Element lastItem = (Element) getChannelElement().getLastChild();
        Element enclosureElement = lastItem.getOwnerDocument().createElement(
                "enclosure");
        enclosureElement.setAttribute("url", entry.getUrl());
        enclosureElement.setAttribute("length", entry.getLength());
        enclosureElement.setAttribute("type", entry.getType());
        lastItem.appendChild(enclosureElement);

    }

    public void trimItems() {
        NodeList items = getChannelElement().getElementsByTagName("item");
        if (items.getLength() > Settings.maxItems) {
            getChannelElement().removeChild(items.item(0));
        }
    }
}