/*
 * Play.java
 */

package org.imp;
import java.io.File;
import java.io.IOException;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;

public class Player extends Thread implements AudioTool {

    private SourceDataLine sourceDataLine;

    private boolean playing;

    private int position;
    
    private int length = -1;

    private AudioInputStream audioInputStream;

    private int playLevel;

    private boolean end;

    public Player() {
        end = false;
        /*
         * tritonus mp3 decoder
         * DataLine.Info info = new DataLine.Info(SourceDataLine.class,
         * Settings.format); //Settings.format sourceDataLine = null; try {
         * sourceDataLine = (SourceDataLine) AudioSystem.getLine(info);
         * System.out.println(sourceDataLine.getLineInfo()); } catch
         * (LineUnavailableException e) { e.printStackTrace(); }
         */
    }

    public void startActivity() {
        playing = true;
        File soundFile = new File(Settings.audioFilename);
        audioInputStream = null;
        try {
            audioInputStream = AudioSystem.getAudioInputStream(soundFile);
            AudioFormat format = audioInputStream.getFormat();
            DataLine.Info info = new DataLine.Info(SourceDataLine.class, Settings.format); //Settings.format format
            sourceDataLine = (SourceDataLine) AudioSystem.getLine(info);
            sourceDataLine.open(format, Settings.bufferSize);
        } catch (Exception e) {
            e.printStackTrace();
        }
        sourceDataLine.start();
        super.start();
    }

    public void run() {
        end = false;
        playing = true;
        int bytes = 0;
      length = (int) audioInputStream.getFrameLength()
                * Settings.frameSize;

        byte[] byteData = new byte[Settings.bufferSize];

        position = 0;
        while (bytes != -1) { 
            try {
                bytes = audioInputStream.read(byteData, 0, Settings.bufferSize);
            } catch (IOException e) {
                e.printStackTrace();
            }
            if (bytes >= 0) {
                position += sourceDataLine.write(byteData, 0,
                        Settings.bufferSize); // bytes
                playLevel = (int) (128 * (float) position / (float) length);
            }
        }
        stopActivity();
        end = true;
    }

    public void stopActivity() {
        sourceDataLine.drain();
        sourceDataLine.stop();
        sourceDataLine.close();
        playing = false;
    }

    public boolean isEnd() {
        return end;
    }

    public int getLevel() {
        return playLevel;
    }

    public boolean getLevelVisible() {
        return !end;
    }

    public int getLength() {
        return length;
    }
}

