package org.imp;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextField;

public class Publisher implements ActionListener {

    private JTextField titleField;

    private JTextField descriptionField;

    private JTextField authorField;

    private EnclosureEntry entry;

    private JDialog dialog;

    public static final SimpleDateFormat RFC822 = new SimpleDateFormat(
            "EEE, d MMM yyyy HH:mm:ss z");

    private String stampedAudioFilename;

    public void publish(EnclosureEntry entry) {
        this.entry = entry;
        createDialog();
        System.out.println("ERT");
    }

    private void createDialog() {
        dialog = new JDialog();
        dialog.setModal(true);
        dialog.setTitle("Metadata");
        Imp.centerWindow(dialog, 300,200);
        Container container = dialog.getContentPane();
        container.setLayout(new BoxLayout(container, BoxLayout.Y_AXIS));
        JLabel titleLabel = new JLabel("Title");
        container.add(titleLabel);
        titleField = new JTextField();
        container.add(titleField);
        JLabel descriptionLabel = new JLabel("Description");
        container.add(descriptionLabel);
        descriptionField = new JTextField();
        container.add(descriptionField);

        JLabel authorLabel = new JLabel("Creator");
        container.add(authorLabel);
        authorField = new JTextField();
        container.add(authorField);

        JButton okButton = new JButton("OK");
        okButton.addActionListener(this);
        container.add(okButton);
        dialog.pack();
        dialog.show();
    }

    public void actionPerformed(ActionEvent e) {
        dialog.dispose();
        doPublication();
    }

    private void doPublication() {
        prepareEntry();
        createFeedFile();
        upload();
    }

    private void prepareEntry() {
        Date now = new Date();
        String date = RFC822.format(now);
        entry.setDate(date);
        System.out.println("title = "+getValue(titleField.getText()));
        entry.setTitle(getValue(titleField.getText()));
      
        entry.setDescription(getValue(descriptionField.getText()));
        entry.setContent(getValue(descriptionField.getText()));
        entry.setAuthor(getValue(authorField.getText()));
        stampedAudioFilename = now.getTime()+ "_" + Settings.audioFilename;
        String url = Settings.httpHost +"/"+ Settings.path+"/"+stampedAudioFilename;
     
        entry.setURIString(url);
        entry.setLink(url);
        entry.setUrl(url);
        entry.setType("audio/mpeg");
        entry.setSourceLink(Settings.httpHost);
        System.out.println(entry.toHTML());
    }
    
    private String getValue(String string){
        if((string == null) || (string.length()==0)){
            string = "not specified";
        }
        return string;
    }

    private void createFeedFile() {
        EnclosureSerializer serializer = new EnclosureSerializer();
        serializer.loadDocumentShell(Settings.rssFilename);
        serializer.addEnclosureEntry(entry);
        serializer.trimItems();
        serializer.write(Settings.rssFilename);
    }

    public void upload() {
        try {
            Uploader uploader = new Uploader();
            System.out.println(Settings.ftpHost);
            String response = uploader.connect(Settings.ftpHost);
            System.out.println(response);
            uploader.login(Settings.user, Settings.pass);
            System.out.println(response);
            uploader.changeDirectory(Settings.path);
            System.out.println(response);
            uploader.uploadFile(Settings.rssFilename);
            System.out.println(response);
            uploader.uploadFile(Settings.audioFilename, stampedAudioFilename);
            uploader.disconnect();
            System.out.println("done");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

