/*
 * Danny Ayers Nov 30, 2004 http://dannyayers.com
 *  
 */
package org.imp;

import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.IOException;

import sun.net.ftp.FtpClient;

// packages

public class Uploader {

    private FtpClient client;

    public Uploader() {
        client = new FtpClient();
    }

    public String connect(String ftpHost) throws IOException {
        client.openServer(ftpHost);
        return client.getResponseString();
    }

    public String login(String user, String pass) throws IOException {
        client.login(user, pass);
        return client.getResponseString();
    }

    public String changeDirectory(String path) throws IOException {
        client.cd(path);
        return client.getResponseString();
    }

    public String getCurrentDirectory() throws IOException {
        client.pwd();
        return client.getResponseString();
    }

    public String uploadFile(String localFilename, String remoteFilename) throws Exception {
        int i = 0;
        byte[] bytesIn = new byte[1024];
        FileInputStream in = new FileInputStream(localFilename);
        BufferedOutputStream out = new BufferedOutputStream(client
                .put(remoteFilename));
        while ((i = in.read(bytesIn)) >= 0) {
            out.write(bytesIn, 0, i);
        }
        in.close();
        out.close();
        return client.getResponseString();
    }
    
    public String uploadFile(String filename) throws Exception{
        return uploadFile(filename,filename);
    }

    public String disconnect() throws IOException {
        client.closeServer();
        return client.getResponseString();
    }

}